/* bits.c
 * Bit manipulations for Kexis
 * NOTE: This code is Buggy for a number of cases, and is DEFINATELY broke
 * on 64 bit, or big edian machines. (read: just about everything but intel)
 * Copyright (C) 2000 Wayde Milas (wmilas@rarcoa.com)
 * 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
 
#include <stdio.h>
#include <stdlib.h>
#include "types.h"
#include "bits.h"
#include "encode.h"
#include "kexis.h"

/* This is just an function used to dump raw bits so I can see what the hell
 * is going on when debugging.
 */
void print_bits(long bits, int len)
{
	int loop=len-1;
	int	hold=0;

	while(loop >= 0) {
		hold = 1<<loop;
		if((bits & hold) != 0)
			printf("1");
		else
		printf("0");

		if((loop % 4) == 0)
			printf(" ");

		loop--;
	}
	printf("  : %ld", bits);
}

void push_bits(KEXISBLOCKSTRUCT *kexisBlock, long outBits, long length,
	OPTIONSTRUCT *options, PCMBLOCKSTRUCT *pcmBlock)
{
	long		assembly=0, hold=0;

	// Check and see if the length of outbits + whats in bitBuck is more
	// than 32. If so, we are in deep shit.
	if(kexisBlock->bitCounter + length >= 32) {
		printf("\nbitCounter: %d  length: %ld\n", kexisBlock->bitCounter, length);
		sprintf(options->errorString, "Bit Overflow in push_bits!");
		handle_error(options);
	}

	debug_prints(0,0, kexisBlock->debugBlockCount, length, 
		kexisBlock->bitCounter,1);
	// Loading outBits into the lower word of assembly.
	assembly = outBits;
	debug_prints(assembly, 32, kexisBlock->debugBlockCount, 0,0,0);
	// shifting assembly into top word, packing tight based on
	// biitcounter.
	assembly <<= ((32 - kexisBlock->bitCounter) - length);
	debug_prints(assembly, 32, kexisBlock->debugBlockCount, 0,0,0);

	// Move bits into transfer
	kexisBlock->bitBucket |= assembly;
	debug_prints(kexisBlock->bitBucket, 32, kexisBlock->debugBlockCount, 0,0,0);

	// adjust bitCounter length;
	kexisBlock->bitCounter += length;

	// check and see if we have assembled 16 bits to push out.
	while(kexisBlock->bitCounter > 15) {

	debug_prints(0,0, kexisBlock->debugBlockCount, -11111, -111111, 1);
		// copy transfer to a hold variable
		hold=kexisBlock->bitBucket;
		debug_prints(hold, 32, kexisBlock->debugBlockCount, 0,0,0);
		// shift hold right 16, we just want the lower word
		hold >>= 16;
		debug_prints(hold, 32, kexisBlock->debugBlockCount, 0,0,0);

		// Set kexisBlock transfer ready to go for next round
		kexisBlock->bitBucket <<= 16;
		debug_prints(hold, 32, kexisBlock->debugBlockCount, 0,0,0);
		kexisBlock->bitCounter -=16;

		kexisBlock->data[kexisBlock->dataPosition] = (short)hold;
		debug_prints(kexisBlock->data[kexisBlock->dataPosition], 16, kexisBlock->debugBlockCount, 0,0,0);
		kexisBlock->dataPosition++;

		// check if we are at the end of the kexisBlock
		if(kexisBlock->dataPosition == UNITS){
			write_kexisblock(options, kexisBlock, pcmBlock);
			kexisBlock->dataPosition = 0;
		}
	}
}

void cleanup_bits(KEXISBLOCKSTRUCT *kexisBlock, OPTIONSTRUCT *options,
	PCMBLOCKSTRUCT *pcmBlock)
{

	kexisBlock->bitBucket >>= 16;
	kexisBlock->data[kexisBlock->dataPosition] = (short)kexisBlock->bitBucket;
	kexisBlock->dataPosition++;

	write_kexisblock(options, kexisBlock, pcmBlock);
}

void debug_prints(long data, long len,
	unsigned long blockPosition, long data1, long data2, long show)
{
	if(DEBUG == 1) {
		if(show == 1 && ((blockPosition >= DEBUG_POS-DEBUG_LEEWAY) &&
			(blockPosition <= DEBUG_POS+DEBUG_LEEWAY))) {
			printf("\nData1: %ld  Data2: %ld\n", data1, data2);
			return;
		}

		if((blockPosition >= DEBUG_POS-DEBUG_LEEWAY) && (blockPosition <= DEBUG_POS+DEBUG_LEEWAY)) {	
			print_bits(data, len);
			printf("\n");
		}
	}
}

long bit_suck(KEXISBLOCKSTRUCT *kexisBlock, long len, PCMBLOCKSTRUCT *pcmBlock,
	OPTIONSTRUCT *options)
{
	unsigned long holdData=0;
	unsigned long holdData2=0;
	size_t holdRead;

	// Fill up the kexisBlock data buffer if its empty.
	if(kexisBlock->blockPointer == 0 && kexisBlock->subBlockPointer == 0) {
		holdRead = fread(kexisBlock->data, sizeof(short), UNITS,
	        options->inFileStream);
		if(holdRead <= 0) {
			sprintf(options->errorString, "Error reading from %s!",
				options->inFileName);
			handle_error(options);
		}
	}

	debug_prints(0,0, kexisBlock->sumTotalSize,len,
		kexisBlock->subBlockPointer, 1);
	debug_prints(0,0, kexisBlock->sumTotalSize, -1, kexisBlock->blockPointer, 1);
	// check and see if we the data we need is gonna be past a short boundry.
	if(kexisBlock->subBlockPointer + len <= 16) {
		// assign holdData
		holdData = kexisBlock->data[kexisBlock->blockPointer];
		debug_prints(holdData, 32, kexisBlock->sumTotalSize, 0,0,0);
		//shift the bits we want all the way to the right
		holdData >>= ((16 - kexisBlock->subBlockPointer) - len);
		debug_prints(holdData, 32, kexisBlock->sumTotalSize, 0,0,0);
		// mask those bits and suck em out.
		holdData2 = holdData & ((1<<len) -1);
		debug_prints(holdData2, 32, kexisBlock->sumTotalSize, 0,0,0);
		// increment our counters.
		kexisBlock->subBlockPointer += len;
		if(kexisBlock->subBlockPointer == 16) {
			if(kexisBlock->blockPointer == UNITS-1)
				kexisBlock->blockPointer=0;
			else
				kexisBlock->blockPointer++;
			kexisBlock->subBlockPointer =0;
		}
		return holdData2;
	}
	else {
	// Data crosses 1 ore more boundries.
	
	// We need to fix this case. Serious overflow.
		if(len-(16-kexisBlock->subBlockPointer) > 16) {
			sprintf(options->errorString, "Bit Overflow in suck_bits!");
				handle_error(options);
		}
		// suck the data in.
		holdData = kexisBlock->data[kexisBlock->blockPointer];
		debug_prints(holdData, 32, kexisBlock->sumTotalSize, 0,0,0);
		// mask lowest bits we need only.
		holdData = holdData & ((1<<(16 - kexisBlock->subBlockPointer)) -1);
		debug_prints(holdData, 32, kexisBlock->sumTotalSize, 0,0,0);
		//shift em left. Check this?
		holdData <<= (len-(16-kexisBlock->subBlockPointer));
		debug_prints(holdData, 32, kexisBlock->sumTotalSize, 0,0,0);

		// read in more data if we need it.
		if(kexisBlock->blockPointer == UNITS-1){
			holdRead = fread(kexisBlock->data, sizeof(short), UNITS,
				options->inFileStream);
			if(holdRead <= 0) {
				sprintf(options->errorString, "Error reading from %s!",
					options->inFileName);
				handle_error(options);
			}
			kexisBlock->blockPointer=0;
		}
		else
			kexisBlock->blockPointer++;

		// grab the second word.
		holdData2 = kexisBlock->data[kexisBlock->blockPointer];
		debug_prints(holdData2, 32, kexisBlock->sumTotalSize, 0,0,0);
		//shift the part we want all the way from the left to teh right.
		holdData2 >>= (16 -(len -(16-kexisBlock->subBlockPointer)));
		debug_prints(holdData2, 32, kexisBlock->sumTotalSize, 0,0,0);
		// mask out any bits we dont need.
		holdData2 = holdData2 & ((1<<(len-(16-kexisBlock->subBlockPointer))) -1);
		debug_prints(holdData2, 32, kexisBlock->sumTotalSize, 0,0,0);
		// combine the two together.
		holdData = holdData | holdData2;
		debug_prints(holdData, 32, kexisBlock->sumTotalSize, 0,0,0);
		// increment the sub block pointer.
		kexisBlock->subBlockPointer = len - (16 - kexisBlock->subBlockPointer);
		return holdData;
	}
}
